library Zeit_Dez_in_hms;

// Delphi 5 DLL-source (Zeit_Dez_in_hms.DLL)    kpaul 08.11.2006
// Wandelt Stunden im Dezimalformat auf 3 Ausgnge h,m,s

uses
  SysUtils,
  Windows,
  Classes;

{$R *.RES}

Const  Inputs =  1;  // number of inputs
       Outputs = 3;  // number of outputs

       {INPUTS}
       hDez   = 0;   // index of input variable hDez

       {OUTPUTS}
       h       = 0;             // index of output variable h
       m       = 1;             // index of output variable m
       s       = 2;             // index of output variable s

       {USER}
       Dezimalstd_old = 0;      // index of user variable Dezimalstd_old


Type TDLLParams = array[0..100] of extended;   //Type of ProfiLab DLL parameters
     PDLLParams = ^TDLLParams;                 // Pointer to ProfiLab DLL parameters

function NumInputs: Byte;
begin
  result:=Inputs;   //Define number of component input pins
end;

function NumOutputs: Byte;
begin
  result:=Outputs;  //Define number of component output pins
end;

Function InputName(Channel: Byte): ShortString; // Return name for each component input pin
begin
   case Channel of
   hDez:   result:='hDez';  //  "hDez"   (Dezimalstundeneingang)
   end;
end;

Function OutputName(Channel: Byte): ShortString; // Return name for each component output pin
begin
   case Channel of
   h:  result:='h';         //  "h"
   m:  result:='m';         //  "m"
   s:  result:='s';         //  "s"
   end;
end;

Procedure SimStart(PInput,POutput,PUser: PDLLParams);   //called when ProfiLab enters RUN mode
begin
   PUser^[Dezimalstd_old]:= -1;                         //dass bei Start Anzeigeroutine durchluft
end;

Procedure SimStop(PInput,POutput,PUser: PDLLParams);    //called when ProfiLab RUN mode is terminated
begin
  // nothing to be done
end;

Procedure Calculate(PInput,POutput,PUser: PDLLParams);  //called regularly from ProfiLab
var Dezimalstd, Dezimalmin: Extended;

begin
  Dezimalstd:= PInput^[hDez];                           //Dezimalstunden bernehmen
  if Dezimalstd <> PUser^[Dezimalstd_old] then          //nur bei nderung durchlaufen
  begin
    POutput^[h]:= INT(Dezimalstd);                      //Stunden ausgeben
    Dezimalmin:= FRAC(Dezimalstd)*60;                   //Dezimalminuten errechnen
    POutput^[m]:= INT(Dezimalmin);                      //Minuten ausgeben
    POutput^[s]:= INT(Frac(Dezimalmin)*60);             //Sekunden ausgeben

    PUser^[Dezimalstd_old]:= Dezimalstd;                //merken
  end;
end;


//export methods for ProfiLab
exports SimStart,
        SimStop,
        NumInputs,
        NumOutputs,
        Calculate,
        InputName,
        OutputName;

begin
end.

